<script>
import moment from "moment";

export default {
  name: "AppointmentList",
  data () {
    return {
      openedAppointment: 0
    };
  },
  computed: {
    appointmentlist () {
      return [...this.$store.getters.appointmentlist].map(appointment => {
        const maxDescriptionLength = 350;

        if (appointment.description && appointment.description.length > maxDescriptionLength) {
          appointment.description = appointment.description.substring(0, maxDescriptionLength) + "&hellip;";
        }
        else if (!appointment.description) {
          appointment.description = "(keine Terminbeschreibung)";
        }

        appointment.description += "<span class='readMore'>" + this.$t("components.AppointmentList.readMore") + "</span>";

        appointment.start = moment(appointment.start);

        if (appointment.end) {
          appointment.end = moment(appointment.end);
        }

        appointment.link = "//" + appointment.proceedingid + "." + location.hostname + "/#/schedule";
        appointment.formattedStartDay = appointment.start.format("D.");
        appointment.formattedStartMonth = this.$t("MonthNames[" + Number(appointment.start.format("M") - 1) + "]").substring(0, 3);
        appointment.formattedStartYear = appointment.start.format("YYYY");
        appointment.formattedDistricts = Object.values(appointment.proceedingdistricts).join(", ");
        return appointment;
      }).sort((a, b) => {
        return a.start > b.start ? 1 : -1;
      }).slice(0, 3);
    }
  },
  created () {
    this.$store.dispatch("appointmentlist");
  },
  methods: {
    openDetails (appointment) {
      const link = "//" + location.hostname + "/" + appointment.proceedingid + "/#/schedule";

      window.open(link);
    }
  }
};
</script>

<template>
  <div class="AppointmentList">
    <section
      v-for="(appointment, index) in appointmentlist"
      :key="'appointment-' + index"
      class="appointment"
      :class="{opened: openedAppointment === index}"
    >
      <header
        @click="openedAppointment = index"
        @keyup.enter="openedAppointment = index"
      >
        <div class="left">
          <p
            class="date"
            tabIndex="0"
            role="button"
          >
            {{ appointment.formattedStartDay }} {{ appointment.formattedStartMonth }} {{ appointment.formattedStartYear }}
          </p>

          <p
            v-if="openedAppointment === index"
            class="districts"
            :title="appointment.formattedDistricts"
          >
            <i class="icon icon-map" />
            {{ appointment.formattedDistricts }}
          </p>
        </div>

        <div class="mid">
          <p
            class="proceedingName"
            :title="appointment.proceedingName"
          >
            {{ appointment.proceedingName }}
          </p>

          <p
            v-if="openedAppointment === index"
            class="title"
            :title="appointment.title"
          >
            {{ appointment.title }}
          </p>
        </div>

        <div class="right">
          <span
            class="icon"
            :class="'icon-chevron_' + (openedAppointment >= index ? 'right' : 'left')"
          />
        </div>
      </header>

      <div
        v-if="openedAppointment === index"
        class="content"
      >
        <p
          class="description"
          @click="openDetails(appointment)"
          @keyup.enter="openDetails(appointment)"
          v-html="appointment.description"
        />
      </div>
    </section>

    <div
      v-if="!appointmentlist.length"
      class="placeholder"
    >
      <p> {{ $t('components.AppointmentList.placeholder') }} </p>
    </div>
  </div>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

div.AppointmentList {
  flex: 1;
  display: flex;
  flex-direction: column;
  overflow: hidden;

  section.appointment {
    display: flex;
    flex-direction: column;
    overflow: hidden;
    margin: 0;
    padding: 2px 2px 0;

    header {
      display: flex;
      flex-direction: row;
      cursor: pointer;

      & > div {
        margin: 0;
        padding: 0;

        & > p {
          margin: 0;
          padding: 0;
        }

        &.left {
          width: 80px;
          overflow: hidden;

          p {
            @extend %fontdefinition_rubric;
            margin: 0;

            &.date {
              padding: 5px;
              border-radius: 5px;
              color: $color_secondary_2;
              background-color: $color_secondary_3;
              text-align: center;
              text-transform: uppercase;
            }

            &.districts {
              color: $color_diagram_03;
              white-space: nowrap;
              text-overflow: ellipsis;
              overflow: hidden;

              i {
                position: relative;
                top: 2px;
                color: $color_diagram_03;
                width: 15px;
              }
            }

            &:focus-visible {
              outline-offset: -3px;
            }
          }
        }

        &.mid {
          flex: 1;
          overflow: hidden;
          margin: 0 5px;

          & > p {
            margin: 0;
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;

            &.proceedingName {
              @extend %fontdefinition_metaline;
            }

            &.title {
              @extend %fontdefinition_subline;
            }
          }
        }

        &.right {
          width: 20px;

          span.icon {
            display: block;
            font-size: 1.25rem;
            color: $color_primary_1;
            text-align: center;
          }
        }
      }
    }

    & > div.content {
      flex: 1;
      overflow: hidden;
      position: relative;

      p.description {
        @extend %fontdefinition_metaline;
        cursor: pointer;
        margin: 0;

        span.readMore {
          @extend %fontdefinition_subline;
          padding-left: 5px;
        }
      }
    }

    &.opened {
      flex: 1;

      header {
        div.left {
          p.date {
            color: $white;
            background-color: $color_primary_1;
          }
        }
      }
    }

    &:not(.opened) {
      border: solid 1px $color_secondary_3;
    }

    &:not(:first-of-type) {
      margin-top: 2px;
    }
  }

  div.placeholder {
    @extend %fontdefinition_body;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
  }
}
</style>
